<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="ifAlone==null?aloneFormRules:formRules"
      label-width="100px"
      v-loading="formLoading"
    >
      <el-form-item label="供应商" prop="supplierId" v-if="ifAlone==null">
        <el-select v-model="formData.supplierId" filterable placeholder="请选择">
          <el-option
            v-for="dict in supplierList"
            :key="dict.id"
            :label="dict.name"
            :value="dict.id"
          />
        </el-select>
      </el-form-item>
<!--      <el-form-item label="产品" prop="productId">-->
<!--        <el-input v-model="formData.productId" placeholder="请输入产品" />-->
<!--      </el-form-item>-->
      <el-form-item label="产品名称" prop="productId">
        <!--        <el-input v-model="formData.productIds" placeholder="请输入联系人负责的产品/业务模块" />-->
        <el-select v-model="formData.productId" filterable placeholder="请选择">
          <el-option
            v-for="dict in productList"
            :key="dict.id"
            :label="dict.name"
            :value="dict.id"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="优势介绍" prop="advantage">
        <el-input type="textarea" v-model="formData.advantage" placeholder="请输入优势介绍" />
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import { CoreProductApi, CoreProductVO } from '@/api/supplier/coreproduct'
import * as SupplierBaseApi from "@/api/supplier/base";
import {SupplierVO} from "@/api/supplier/base";
import {FormRules} from "element-plus";
import * as SupplierDetailApi from "@/api/supplier/product/supplierdetail";

/** 供应商核心产品 表单 */
defineOptions({ name: 'CoreProductForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗
const supplierList = ref([] as SupplierVO[])
const productList = ref([] as SupplierProductVo[])
const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  supplierId: undefined,
  supplierName: undefined,
  productId: undefined,
  productName: undefined,
  advantage: undefined,
})
const formRules = reactive<FormRules>({
  // supplierId: [{ required: true, message: '供应商不能为空', trigger: 'blur' }],
  productId: [{ required: true, message: '产品名称不能为空', trigger: 'blur' }],
})
const aloneFormRules = reactive<FormRules>({
  supplierId: [{ required: true, message: '供应商不能为空', trigger: 'blur' }],
  productId: [{ required: true, message: '产品名称不能为空', trigger: 'blur' }],
})
const formRef = ref() // 表单 Ref
const props = defineProps({
  supplierId: { type: Number, default: () => null },
  ifAlone: { type: Boolean, default: () => null },
})
/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await CoreProductApi.getCoreProduct(id)
    } finally {
      formLoading.value = false
    }
  }
  supplierList.value = await SupplierBaseApi.Api.getAll()
  productList.value = await SupplierDetailApi.getAll()
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as CoreProductVO
    if (props.ifAlone!=null) {
      if (!props.supplierId.receivedParam){
        message.error("请先保存供应商基本信息");
        return
      }
      data.supplierId = props.supplierId.receivedParam
    }
    if (formType.value === 'create') {
      await CoreProductApi.createCoreProduct(data)
      message.success(t('common.createSuccess'))
    } else {
      await CoreProductApi.updateCoreProduct(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    supplierId: undefined,
    productId: undefined,
    productName: undefined,
    advantage: undefined,
  }
  formRef.value?.resetFields()
}
</script>
